/*
    BTPlusPlus 0.98
    Copyright (C) 2004-2006 Damian "Rush" Kaczmarek

    This program is free software; you can redistribute and/or modify
    it under the terms of the Open Unreal Mod License version 1.1.
*/

class FlagDisposer extends Actor;

var BTPlusPlus Controller;
var byte Team;
var FlagBase	HomeBase;
var CTFFlag Flag;
var Pawn Holder;
var CTFFlag NewFlag;

function SetHolderLighting()
{
	Holder.AmbientGlow = 254;
	LightType = LT_None;
	Holder.LightEffect=LE_NonIncidence;
	Holder.LightBrightness=255;
	//red light for red flag and blue for blue flag
	if(Team==0)
		Holder.LightHue=0;
	else
		Holder.LightHue=170;
	Holder.LightRadius=6;
	Holder.LightSaturation=LightSaturation;
	Holder.LightType=LT_Steady;
}

function ScoreFlag(Pawn Scorer, CTFFlag theFlag, int time)
{
	local pawn TeamMate;
	local Actor A;

	CTFGame(Level.Game).Teams[Scorer.PlayerReplicationInfo.Team].Score += 1.0;
	
	Scorer.PlayerReplicationInfo.Score += 7.0f;

	BroadcastLocalizedMessage( class'CTFMessage', 0, Scorer.PlayerReplicationInfo, None, TheFlag );

	for ( TeamMate=Level.PawnList; TeamMate!=None; TeamMate=TeamMate.NextPawn )
	{
		if ( TeamMate.IsA('TournamentPlayer'))
			PlayerPawn(TeamMate).ClientPlaySound(CTFGame(Level.Game).CaptureSound[Scorer.PlayerReplicationInfo.Team]);
	}
	if ( theFlag.HomeBase.Event != '' )
		foreach allactors(class'Actor', A, theFlag.HomeBase.Event )
			A.Trigger(theFlag.HomeBase,	Scorer);
			
    if((CTFGame(Level.Game).bOverTime || (CTFGame(Level.Game).GoalTeamScore != 0)) && (CTFGame(Level.Game).Teams[Scorer.PlayerReplicationInfo.Team].Score >= CTFGame(Level.Game).GoalTeamScore) )
		CTFGame(Level.Game).EndGame("teamscorelimit");
	else if ( CTFGame(Level.Game).bOverTime )
		CTFGame(Level.Game).EndGame("timelimit");
}

function Touch(Actor Other)
{
	local CTFFlag 	aFlag;
	local PlayerPawn aPPawn;
	local int 		ID, delta;
	local int 		BestTime, BestTimeClient, TimeStampClient;
	local int 		NewTime;
	local int 		TimeStamp;
	local string 	BestTimeClientStr, ctf;
	local float		Stamp;
	
	//real player showing up?
	if ((Other != None) && Other.isA('TournamentPlayer'))
	{
		Stamp = Level.TimeSeconds;
		
		aPPawn = PlayerPawn(Other);
		ID = Controller.FindPlayer(aPPawn);

		if(aPPawn.AttitudeToPlayer == ATTITUDE_Follow || aPPawn.Health <= 0)
			return;//go respawning dude

		//no boost caps if recs are not allowed
		if(Controller.CheckIfBoosted(ID) && (Controller.RecordsWithoutBoost == 1 || (Controller.RecordsWithoutBoost == 2 && !Controller.bCooperationMap)))
			return;

		// check if scored capture
		if (aPPawn.PlayerReplicationInfo.Team == Team)
		{
			if (aPPawn.PlayerReplicationInfo.HasFlag != None)
			{
				//CAPTURE
				//keep old trick for polycap - protection
				aPPawn.AttitudeToPlayer = ATTITUDE_Follow;
				//no flagtaking before respawn
				Controller.PlayerCapped(ID);
				aPPawn.SetCollision(False);
				//Score!
				aFlag = CTFFlag(aPPawn.PlayerReplicationInfo.HasFlag);
				//measure captime
				NewTime = Controller.MAX_CAPTIME - Controller.MeasureTime(ID, Stamp);
				
				TimeStamp = Controller.CurTimestamp();//make the timestamp
				BestTime = Controller.GetBestTimeServer(ID); // on the current map
				BestTimeClient = Controller.GetBestTimeClient(ID); // set in client's user.ini
				BestTimeClientStr = Controller.GetBestTimeClientStr(ID);
				TimestampClient = Controller.GetTimeStampClient(ID);
				//Log("Cap: ini-time " $ BestTimeClient $ "/ str= " $ BestTimeClientStr, 'debug');//@test
				if(Controller.bNoCapSuicide && InStr(Caps(string(Level.Game.class)), Caps("BunnyTrack")) != -1)
					ScoreFlag(aPPawn, aFlag, NewTime);
				else
					CTFGame(Level.Game).ScoreFlag(aPPawn, aFlag);
			
				
				aFlag.SendHome();
				aPPawn.PlayerReplicationInfo.HasFlag = None;

				if(Controller.bMultiFlags)//multiflags -> destroy this one
					aFlag.Destroy(); 

				// make the lights around the player normal
				aPPawn.AmbientGlow = aPPawn.Default.AmbientGlow;
				aPPawn.LightType = LT_None;

				Controller.SendEvent("btcap", aPPawn.PlayerReplicationInfo.PlayerID, NewTime, TimeStamp);

				//BT++ ignores 100 minutes +
				if(newTime > 0)
				{
					//see if this was a new reference-run
					ctf = Controller.KeepCheckpointTimes(ID, NewTime);
				}

				if(!Controller.GetSTFU(ID))
				{
					aPPawn.ClearProgressMessages();
	    			aPPawn.SetProgressTime(9);
					if(NewTime>BestTime)//improved captime or first cap in this game
			    	{
						aPPawn.SetProgressColor(Controller.GreenColor, 0);
						aPPawn.SetProgressMessage("Cap Time: "$ctf, 0);
						//maprecord broken
						if(NewTime > Controller.MapBestTime && Controller.MapBestTime != 0)
						{
							if(BestTimeClient!=0 && BestTimeClient != -1 && NewTime > BestTimeClient)
							{
								//show improvement
								delta = NewTime - BestTimeClient;
								//aPPawn.SetProgressColor(Controller.GreenColor, 1);
								aPPawn.SetProgressMessage("You have beaten your record (" $ ((Timestamp - TimestampClient)/86400) $ " day(s) old) by "$Controller.FormatCentiseconds(delta, True)$ " !", 1);
								aPPawn.SetProgressMessage("Previous was: "$BestTimeClientStr, 2);
								
								//improvement of the server record
								delta = NewTime - Controller.MapBestTime;
								//aPPawn.SetProgressColor(Controller.GreenColor, 3);
								aPPawn.SetProgressMessage("You have beaten the map record by " $ Controller.FormatCentiseconds(delta, True) $"!!!", 3);
								aPPawn.SetProgressMessage("Previous was: "$Controller.GRI.MapBestTime$" (set by "$Controller.MapBestPlayer@Controller.GRI.MapBestAge$ " day(s) ago)", 4);

							}
							else
							{
								//improvement of the server record
								delta = NewTime - Controller.MapBestTime;
								//aPPawn.SetProgressColor(Controller.GreenColor, 1);
								aPPawn.SetProgressMessage("You have beaten the map record by " $ Controller.FormatCentiseconds(delta, True) $"!!!", 1);
								aPPawn.SetProgressMessage("Previous was: "$Controller.GRI.MapBestTime$" (set by "$Controller.MapBestPlayer@Controller.GRI.MapBestAge$ " day(s) ago)", 2);
								
								//ignore PB; rare case that not improved own but broke maprecord
							}
						}
						else if(BestTimeClient!=0 && BestTimeClient != -1)//valid pb time was saved and transmitted to the server
						{
							if(NewTime > BestTimeClient)//improved personal record
							{
								//show improvement
								delta = NewTime - BestTimeClient;
								//aPPawn.SetProgressColor(Controller.GreenColor, 2);
								aPPawn.SetProgressMessage("You have beaten your record (" $ ((Timestamp - TimestampClient)/86400) $ " day(s) old) by "$Controller.FormatCentiseconds(delta, True)$ " !", 2);
								aPPawn.SetProgressMessage("Previous was: "$BestTimeClientStr, 3);
								if(Controller.MapBestTime != 0)
									aPPawn.SetProgressMessage("Server record is: "$Controller.GRI.MapBestTime$" (set by "$Controller.MapBestPlayer$")",4);
							}
							else//1st cap = worse than personal record
							{
								aPPawn.SetProgressMessage("Your record is: "$BestTimeClientStr,2);
								if(Controller.MapBestTime != 0)
									aPPawn.SetProgressMessage("Map record is: "$Controller.GRI.MapBestTime$" (set by "$Controller.MapBestPlayer$")",3);

								//show difference to personal record
								delta = BestTimeClient - NewTime;
								aPPawn.SetProgressColor(Controller.OrangeColor, 4);
								if(delta != 0)
									aPPawn.SetProgressMessage("Compared to your record +" $ Controller.FormatCentiseconds(delta, True), 4);
								else
									aPPawn.SetProgressMessage("Same time as your record :)", 4);
							}
						}
						else if(Controller.MapBestTime != 0)//no pb present
						{
							aPPawn.SetProgressMessage("First cap on this map? Congratulations!",2);
							aPPawn.SetProgressMessage("Server record is: "$Controller.GRI.MapBestTime$" (set by "$Controller.MapBestPlayer$")",3);
						}
						else//also no server record
							aPPawn.SetProgressMessage("You did the first cap on record for this map.",2);
					}
					else//worse cap for this game -> worse than pb
					{
						aPPawn.SetProgressColor(Controller.GreenColor, 0);
						aPPawn.SetProgressMessage("Cap Time: "$ctf, 0);
						if(BestTimeClient!=0)
							aPPawn.SetProgressMessage("Your record is: "$BestTimeClientStr,2);
						if(Controller.MapBestTime != 0)
							aPPawn.SetProgressMessage("Map record is: "$Controller.GRI.MapBestTime$" (set by "$Controller.MapBestPlayer$")",3);

						//show difference to personal record
						delta = - NewTime + BestTimeClient;
						aPPawn.SetProgressColor(Controller.OrangeColor, 4);
						if(delta != 0)
							aPPawn.SetProgressMessage("Compared to your record +" $ Controller.FormatCentiseconds(delta, True), 4);
						else
							aPPawn.SetProgressMessage("Same time as your record :)", 4);

					}
				}
				
				if(NewTime > 0)
					Controller.SetBestTime(NewTime, TimeStamp, ID, ctf);
				

				if(Controller.bRespawnAfterCap)
				{
					aPPawn.Weapon.bCanThrow = false; // just in case someone doesn't play with Insta
					Level.Game.DiscardInventory(aPPawn);
					//stop the player
					aPPawn.AddVelocity(-aPPawn.velocity);
					aPPawn.SetPhysics(PHYS_None);
										
					/* if not the end of game, teleport the player to the start point */
					if(!Level.Game.bGameEnded)
					{
						Level.Game.PlayTeleportEffect(aPPawn, True, True);
						aPPawn.bHidden=True;
						aPPawn.GoToState('Dying');
					}
				}
			}
		}
		// no flag ? please take one :)
		else if(aPPawn.PlayerReplicationInfo.HasFlag == None && Controller.bMultiFlags)
		{
			// Let me see .... which one to spawn ? Red or blue one ?
			if(Team==1)
				NewFlag = Spawn(class'BTPPFlagBlue');
			else
				NewFlag = Spawn(class'BTPPFlagRed');
			// Spawning from external package failure ....
			if(NewFlag==None)
			{
				log("BTPlusPlus: Error, you did not add BTPlusPlusv098_C to ServerPackages !!!");
				if(Team==1)
					NewFlag = Spawn(class'CTFFlag');
				else
					NewFlag = Spawn(class'RedFlag');
			}
			//Need to set a few variables to avoid Accessed Nones
			NewFlag.Skin = Flag.Skin;
			NewFlag.Team = Team;
			NewFlag.HomeBase = HomeBase;
			NewFlag.Holder = aPPawn;
			NewFlag.GotoState('Held');
			Flag.bHome = True;  //Fixes the CTFHud
			HomeBase.bHidden = false;  //Changes the variable set by GoToState('Held')
			NewFlag.Skin = Flag.Skin; //Compatibility with custom flag textures
			Holder = aPPawn;
			Holder.MoveTimer = -1;
			Holder.PlayerReplicationInfo.HasFlag = NewFlag;
			//Do everything as the normal flag script do ....
			Holder.MakeNoise(2.0);
			SetHolderLighting();
			if ( Holder.IsA('TournamentPlayer') && TournamentPlayer(Holder).bAutoTaunt )
				Holder.SendTeamMessage(None, 'OTHER', 2, 10);

			if (Level.Game.LocalLog != None)
				Level.Game.LocalLog.LogSpecialEvent("flag_taken", Holder.PlayerReplicationInfo.PlayerID, CTFGame(Level.Game).Teams[Team].TeamIndex);
			BroadcastLocalizedMessage( class'CTFMessage', 6, Holder.PlayerReplicationInfo, None, CTFGame(Level.Game).Teams[Team] );
		}
	}
}

defaultproperties
{
     CollisionRadius=48.000000
     CollisionHeight=30.000000
     bStatic=False
     bHidden=True
     bCollideActors=True
     NetPriority=3.000000
}
