/*
    BTPlusPlus 0.98
    Copyright (C) 2004-2006 Damian "Rush" Kaczmarek
	final task for old RecordData -> transform old records to new ones

    This program is free software; you can redistribute and/or modify
    it under the terms of the Open Unreal Mod License version 1.1.
*/

class RecordData expands Actor config(BTRecords);

var config string Record[255];
var config int RecordsNum;
var BTPlusPlus Main;

//====================================
// TransformRecords - converts old records from old format in [BTPlusPlus.RecordData] to new recs in [BTPlusPlus.ServerRecords]
// Triggered in: class'BTPlusPlus'.Mutate
//====================================
function string TransformRecords(ServerRecords RD_new)
{
	local int i, j, en, time;
	local string temp;

	for(i=0;i<255;i++)
	{
		if(Record[i]=="")
			continue;
		en = Main.ElementsNum(Record[i], chr(11));
		for( j=1;j<=en;j++)
		{
			temp=Main.SelElem(Record[i], j, chr(11));
			
			time = 1999 - int(Main.SelElem(temp, 2, chr(9)));
			if(time % 11 != 0f)
				RD_new.AddRecord(Main.SelElem(temp, 1, chr(9)),599999 - time*1000/11,
						Trim(Main.SelElem(temp, 3, chr(9))), int(Main.SelElem(temp, 4, chr(9))), True);
			else
				RD_new.AddRecord(Main.SelElem(temp, 1, chr(9)),600000 - time*1000/11,
						Trim(Main.SelElem(temp, 3, chr(9))), int(Main.SelElem(temp, 4, chr(9))), True);
		}
	}
	//now we save once
	RD_new.SaveConfig();
}

//remove spaces added and " that are bad with new format
static final function string Trim(string player)
{
	local int i;

	//trim
	while(Right(player, 1) ~= " ")
		player = Left(player, Len(player) - 1);

	i = InStr(player, Chr(34));
	while(i != -1)
	{
		player = Left(player, i) $ Mid(player, i + 1);
		i = InStr(player, Chr(34));
	}
	
	i = InStr(player, "?");
	while(i != -1)
	{
		player = Left(player, i) $ Mid(player, i + 1);
		i = InStr(player, "?");
	}
	
	i = InStr(player, "\\");
	while(i != -1)
	{
		player = Left(player, i) $ Mid(player, i + 1);
		i = InStr(player, "\\");
	}
	
	return player;
}

DefaultProperties
{
	bHidden=True
	RecordsNum=-1
}
