/*
    BTPlusPlus 0.98
    Copyright (C) 2004-2006 Damian "Rush" Kaczmarek
	last task is to transform old recs to new recs -> in BTPPUsers domain

    This program is free software; you can redistribute and/or modify
    it under the terms of the Open Unreal Mod License version 1.1.
*/

class UserConfig expands Info config(BTRecords);
/* class holding information(records, config) clientside  */

var config bool bSet; // is set to true after the first antiboost status change, if it is false, BT++ will send a more detailed help
var config bool bAntiBoost; // for storing AntiBoost status between switching servers
var config bool bBTHud; // indicates showing BTPPHudMutator
var config bool bSTFU; // prevents from recieving BT++ messages
var config string Record[255];

replication {
	reliable if(Role == ROLE_Authority)
		TransformRecords;
}

// destroy selft if owner leaves the server
function Tick(float DeltaTime)
{
	if(PlayerPawn(Owner) == None)
		Destroy();
}

//====================================
// TransformRecords - converts old records from old format in [BTPlusPlusv098.UserConfig] to new recs in [BTPPUser.ClientData]
// Triggered in: class'BTPlusPlus'.Mutate
//====================================
simulated function TransformRecords(ClientData UC_new)
{
	local int i, j, en, time, index;
	local string temp, map;

	if(ROLE == ROLE_Authority)
		return;

	for(i=0;i<255;i++)
	{
		if(Record[i]=="")
			continue;

		en = ElementsNum(Record[i], chr(11));
		for( j=1;j<=en;j++)
		{
			
			temp = SelElem(Record[i], j, chr(11));
			
			map = SelElem(temp, 1, chr(9));

			//needed
			index = UC_new.CheckRecord(map);
			
			time = 1999 - int(SelElem(temp, 2, chr(9)));
			if(time % 11 != 0f)
				UC_new.AddRecord(map, 599999 - time*1000/11, int(SelElem(temp, 3, chr(9))), True, index);
			else
				UC_new.AddRecord(map, 600000 - time*1000/11, int(SelElem(temp, 3, chr(9))), True, index);
		}
	}
	//now we save once
	UC_new.SaveConfig();
}

//#########################################################################
//### TEXT FUNCTIONS - these are clientside clones of text functions in class'BTPlusPlus'
//#########################################################################

static final function int ElementsNum(string Str, optional string Char)
{
	local int count, pos;

	if(Char=="")
		Char=chr(9);

	while(true)
	{
		pos = InStr(Str, Char);
		if(pos == -1)
			break;
		Str=Mid(Str, pos+1);
		count++;
	}
	return count+1;
}

static final function string SelElem(string Str, int Elem, optional string Char)
{
	local int pos;
	if(Char=="")
		Char=chr(9);

	while(Elem>1)
	{
		Str=Mid(Str, InStr(Str, Char)+1);
		Elem--;
	}
	pos=InStr(Str, Char);
	if(pos != -1)
    	Str=Left(Str, pos);
    return Str;
}


DefaultProperties
{
	bAntiBoost=True
	bBTHud=True
}
